]> arthur.barton.de Git - backup-script.git/blobdiff - bin/backup-script-wrapper
backup-status: Don't read ${conf_d}/backup-script.conf twice
[backup-script.git] / bin / backup-script-wrapper
index 61ef2434ead9561073dc775666e309e620722e8a..32a15a66bf40eb7fac8732c2908b7b42a77eac6f 100755 (executable)
@@ -1,7 +1,7 @@
-#!/bin/sh
+#!/bin/bash
 #
 # backup-script system for cloning systems using rsync
-# Copyright (c)2008-2013 Alexander Barton, alex@barton.de
+# Copyright (c)2008-2015 Alexander Barton, alex@barton.de
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
 # Please read the file COPYING, README and AUTHORS for more information.
 #
 
-MAILTO="logcheck"
+if [ -z "$MAILTO" ]; then
+       if id "logcheck" >/dev/null 2>&1; then
+               MAILTO="logcheck"
+       elif fgrep "logcheck:" /etc/aliases >/dev/null 2>&1; then
+               MAILTO="logcheck"
+       else
+               MAILTO="root"
+       fi
+fi
 
 NAME="backup-script"
-HOST=`hostname`
-TMP="/tmp/$NAME.$$"
+
+DELIMITER="- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -"
+HOST=`hostname -f`
+LOGFILE="/var/log/$NAME.log"
+PIDFILE="/var/run/$NAME.pid"
+SUBJECT="$NAME results"
+TMP=`mktemp /tmp/$NAME.XXXXXXXX` || exit 1
 
 PATH="$PATH:/bin:/sbin:/usr/bin:/usr/sbin:/usr/local/bin:/usr/local/sbin"
 export PATH
 
-`dirname "$0"`/backup-script $* >>$TMP 2>&1
+# check PID file ("lock file")
+if [ -e "$PIDFILE" ]; then
+       echo "Lockfile \"$PIDFILE\" already exists."
+       echo "Is an other instance still running?"
+       echo
+       echo -n "Aborted: "; date
+       echo
+       exit 4
+fi
+
+exec >"$TMP" 2>&1
+
+echo "$NAME Report"
+echo
+echo " - Host: `hostname -f`"
+echo " - User: `id -un`"
+echo
+
+if echo "$DELIMITER" >>"$LOGFILE" 2>/dev/null; then
+       echo >>"$LOGFILE"
+       "$(dirname "$0")/backup-script" "$@" | tee -a "$LOGFILE"
+       r=${PIPESTATUS[0]}
+else
+       "$(dirname "$0")/backup-script" "$@"
+       r=$?
+       echo "(Can't write logfile: \"$LOGFILE\"!)"
+fi
+
+case "$r" in
+       0)
+               ;;
+       *)
+               SUBJECT="$SUBJECT - with ERRORS!"
+esac
 
-cat $TMP | mail -s "$HOST: $NAME results" "$MAILTO"
+cat "$TMP" | mail -s "$HOST: $SUBJECT" "$MAILTO"
 
-rm -f $TMP
+rm -f "$TMP"
+exit $r
 
 # -eof-